#!/usr/bin/perl -w

use strict;

my $BUCKET_SIZE = 0.1;
my $last_thread = -1;
my $last_end;
my @ctx;
my %hist;

while (my $line = <STDIN>) {
    if ($line =~ /^tracerec: ([0-9]+) ([0-9\.]+) ([0-9\.]+) [0-9\.]+ [0-9\.]+$/) {
	
	my $thread = $1;
	my $start = $2;
	my $end = $3;
	
	if ($last_thread != -1 && 
	    $thread != $last_thread) {
	    my $gap = 1000 * ($start - $last_end);
	    push @ctx, $gap;
	    my $bucket = int ($gap/$BUCKET_SIZE);
	    $hist{$bucket}++;
	}
	
	$last_thread = $thread;
	$last_end = $end;
    }
}

my $len = scalar (@ctx);

sub bynum {
    $a <=> $b;
}

my @ctx2 = sort bynum @ctx;

open OUTF, ">ctx_hist.dat" or die;

foreach my $val (sort bynum keys %hist) {
    print OUTF $val*$BUCKET_SIZE." $hist{$val}\n";
}

close OUTF;

print "25th %ile ".$ctx2[int($len*0.25)]."\n";
print "50th %ile ".$ctx2[int($len*0.50)]."\n";
print "75th %ile ".$ctx2[int($len*0.75)]."\n";
